<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Mon Oct 11 15:54:45 2004

    Any changes made here will be lost.
-->
<methoddef>
<name>forward_vm</name>
<version>1.0</version>
<signature>array array</signature>
<help>
Forwards a voicemail message somewhere.
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
###############################################################################
#
#   Sub Name:       forward_vm
#
#   Description:    Forwards a voicemail email to someone
#
#   Arguments:      NAME      IN/OUT  TYPE      DESCRIPTION
#                   $srv      in      ref       Server object instance
#                   $req      in      arrayref  Array ref
#                    [ email, file_path, from_name, from_email, subject, body ]
#
#   Globals:        None.
#
#   Environment:    None.
#
#   Returns:        None.
#
###############################################################################
sub forward_vm
{
open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: forward_vm.xpl(@_)\n"; close(LOG);
        my ($srv, $req) = @_;

	use strict;
	use Mail::Sender;

	my ($email, $file, $fromname, $fromemail, $subject, $body);

	# make sure the data passed was an array ref
	if (ref($req) ne "ARRAY")
	{
		return "Must pass an array ref of data";
	}
	else
	{
		($email, $file, $fromname, $fromemail, $subject, $body) = @{$req};
	}

	# set default subject if necesarry
	$subject ||= "Voicemail from $fromname";

	# set default body if necesarry
	$body ||= <<"*END*";
$fromname has sent you a voicemail.

You can double click the attached file to hear it on your computer speakers.

*END*


	my $vmroot = "/var/spool/asterisk/voicemail/default/";

	if ($email !~ /^[^\@\s\$]+\@(?:[a-z0-9-]+\.)+[a-z]+$/i)
	{
		return "Invalid email address";
	}

	$fromemail ||= "$fromname.nonexistant\@fonality.com";
	$fromemail =~ s/ /./g;

	$file = "$vmroot/$file";

	unless (-e $file)
	{
		return "No such file $file";
	}

        my $sender = new Mail::Sender
        {
                smtp    => 'localhost',
                from    => "\"$fromname\" <$fromemail>",
        };

        $sender->OpenMultipart(
        {
                to      => $email,
                subject => $subject,
        });

        $sender->Body;
        $sender->SendEnc($body);

        $sender->Attach(
        {
                file    => $file,
        });

	$sender->Close;

	return 1;

}

__END__
]]></code>
</methoddef>
