#!/usr/bin/perl

use Fcntl qw/:flock/;

my $specific = shift;

# REMOVED DUE TO ASTERISK CRASHES WHEN MULTIPLE RELOADS (e.g. 'reload' and 'reload app_voicemail.so') OCCUR
$specific = undef;

my $filename = "/tmp/.reload_asterisk_flag_$specific";
$filename =~ s/ /_/g;

open(LOG, ">>/tmp/xpl.log");
print LOG localtime() . ": $0: $$: creating $filename\n";
close(LOG);

open my $flag, "> $filename" or die $!;

# Non-blocking flock.
unless( flock( $flag, LOCK_NB | LOCK_EX ) )
{
	exit(0);
}

sleep(5);

my $reload;
if ($specific =~ /\.so$/)
{
	$reload = "reload $specific";
}
elsif ($specific)
{
	# don't allow "extensions reload", can cause crashing on asterisk 1.2 if two happen at the same time
	if ($specific eq "extensions")
	{
		$reload = "reload";
	}
	else
	{
		$reload = "$specific reload";
	}
}
else
{
	$reload = "reload";
}

open(LOG, ">>/tmp/xpl.log");
print LOG localtime() . ": $0: $$: /usr/sbin/asterisk -r -x '$reload'\n";
close(LOG);

system( "/usr/sbin/asterisk -r -x '$reload'" );

# Free the flock
close($flag);

