<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Sat Sep  4 08:46:57 2004

    Any changes made here will be lost.
-->
<methoddef>
<name>voicemail</name>
<version>1.0</version>
<signature>struct struct</signature>
<help>
List voicemails for an extension, Returns a hash of hashrefs
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
###############################################################################
#
#   Sub Name:       voicemail
#
#   Description:    Send a hello message
#
#   Arguments:      NAME      IN/OUT  TYPE      DESCRIPTION
#                   $srv      in      ref       Server object instance
#
#   Globals:        None.
#
#   Environment:    None.
#
#   Returns:        None.
#
###############################################################################
sub voicemail
{
open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: voicemail.xpl(@_)\n"; close(LOG);
        use strict;
        my($srv, $req) = @_;

	my $extension = $req->{extension};

        return "Extension ($extension) must be numeric" if $extension !~ /^\d+$/;
        my $vmdir = "/var/spool/asterisk/voicemail/default/$extension";

        # create a hash of hashrefs, keys are folder names
        my %folders;

        if (-e $vmdir)
        {
                # get the folders for the extension
                opendir(EXTEN, $vmdir) || return "Couldn't open vmdir $vmdir: $!";
                foreach my $folder (grep { !/^\./ && -d "$vmdir/$_" } readdir(EXTEN))
                {
                        $folders{$folder} = {};

                        # get all the files in the dir
                        opendir(FOLDER, "$vmdir/$folder") || return "Couldn't open folder $vmdir/$folder: $!";
                        foreach my $file (grep { /\.txt$/ } readdir(FOLDER))
                        {
                                $folders{$folder}{$file} = {};

                                open(TXT, "<$vmdir/$folder/$file") || return "Couldn't open text $vmdir/$folder/$file: $!";
                                while (<TXT>)
                                {
                                        next if /^\s*;|^\s*$/;

                                        $folders{$folder}{$file}{$1} = $2 if /^\s*(\S+)\s*=\s*(.*)$/;
                                }
				close(TXT);
                        }
			closedir(FOLDER);
                }
                closedir(EXTEN);
        }
        else
        {
                return "vmdir $vmdir doesn't exist or we do not have correct permissions";
        }

        return \%folders;
}


__END__
]]></code>
</methoddef>
